
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'dbo.[KD_GRAPH_TABLE_SAVE]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE dbo.[KD_GRAPH_TABLE_SAVE]

GO

CREATE PROCEDURE KD_GRAPH_TABLE_SAVE
	@varKSparLINK			int,
	@varKSparDAY			int,
	@varKSparHOUR			numeric(10,2),
	@varKSparDayType		int
AS
DECLARE @varKSSQLError	int,
	    @varKSRowCount	int,
		@varKStrancount	int
SET @varKStrancount = @@TRANCOUNT
SET IMPLICIT_TRANSACTIONS ON
BEGIN TRAN
COMMIT TRAN

	SELECT @varKSparLINK = LINK FROM GRAPHICS WITH (UPDLOCK) WHERE LINK = @varKSparLINK
	SELECT @varKSSQLError = @@ERROR, @varKSRowCount = @@ROWCOUNT
	IF @varKSSQLError <> 0
	BEGIN
		ROLLBACK
		RETURN 7
	END
	IF @varKSRowCount = 0
	BEGIN
		ROLLBACK 
		RETURN 3
	END
	SELECT @varKSparDayType = LINK FROM TYP_DAYS WITH (UPDLOCK) WHERE LINK = @varKSparDayType
	SELECT @varKSSQLError = @@ERROR, @varKSRowCount = @@ROWCOUNT
	IF @varKSSQLError <> 0
	BEGIN
		ROLLBACK
		RETURN 7
	END
	IF @varKSRowCount = 0
	BEGIN
		ROLLBACK 
		RETURN 3
	END

	IF NOT EXISTS (SELECT * FROM dbo.GRAPHIC_DAYS WHERE LINK_UP = @varKSparLINK and [DAY] = @varKSparDAY and DAY_TYPE = @varKSparDayType)
		INSERT GRAPHIC_DAYS (LINK_UP,DAY,HOURS,DAY_TYPE) VALUES (@varKSparLINK, @varKSparDAY, @varKSparHOUR,@varKSparDayType)
	IF @@ERROR <> 0
	BEGIN
		ROLLBACK
		RETURN 7
	END

WHILE @@TRANCOUNT > @varKStrancount
	COMMIT TRAN
RETURN 0



GO


GRANT EXECUTE ON dbo.[KD_GRAPH_TABLE_SAVE] TO PUBLIC

GO


DELETE FROM G_PROV1_OBJECT WHERE OBJECT = (SELECT LINK FROM dbo.S_OBJECTS WHERE CODE = 'DOC_DEP_OS_OPT_TYP_LINK')
GO


Declare @kassa int, @BB datetime, @BE datetime
SELECT @BB = BEGINDATE, @BE = ENDDATE
FROM ADMIN_INFO

IF @BB IS NULL OR @BE IS NULL
BEGIN
	Select @kassa = LINK from S_OBJECTS Where CODE = 'KASSA'
	SELECT @BB = '20100101', @BE = '20100101'
	EXECUTE I_SET_ADMIN_DATE @kassa, @BB, @BB, @BE
END
GO

select * FROM DBO.S_OBJECTS WHERE left(CODE,23) = 'DEP_ACC_DETAILS_OPTIONS'
GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[DICTIONARY_STAFF_FN]') AND xtype in (N'FN', N'IF', N'TF'))
DROP FUNCTION [DICTIONARY_STAFF_FN]

GO


CREATE    FUNCTION dbo.DICTIONARY_STAFF_FN(@dDATE DATETIME = null) RETURNS TABLE 
AS RETURN
SELECT 
	sh.link, 
	[staff_link] = s.link, sh.dep_link,
	s.subdiv_link,
	[subdiv_code] = sd.code,
	[subdiv_name] = SD.NAME,
	s.post_link,
	[post_code] = P.CODE,
	[post_name] = P.NAME,
	s.num_stake,
	[free_stakes] = s.num_stake - isnull((SELECT sum(case when (STAFF_OPT1.OPT = 1 and es.status = 2) or (STAFF_OPT3.OPT = 1 and es.status = 3) then 0 else es.num_stake end) 
							FROM dbo.empl_staff(@dDATE) es left join (select OPT = dbo.sa_get_option_by_code('KADRY_OPT1')) STAFF_OPT1 on 1=1 
														left join (select OPT = dbo.sa_get_option_by_code('KADRY_OPT3')) STAFF_OPT3 on 1=1
							WHERE es.staff_head=sh.link and es.notwork=0
					 and not exists(SELECT * FROM item_dis_face WHERE active=1 and empl_link=es.empl_link and dis_date<=isnull(@dDate, ui.workdate))), 0),
	--s.oklad, 
	oklad = Coalesce(Oklad.SUMMA,0),
	s.ets_razr,
	s.ets_razr2,
	s.kat_link,	
	[kat_CODE] = K.CODE,
	[kat_name] = K.name,
	s.gossl,
	[post_type_name] = pt.name,
	s.fin, s.fin_fond, 
	s.kat_gos_link,
	[kat_gos_CODE] = KG.CODE,
	[kat_gos_name] = KG.name,
	s.gr_gos_link,
	[gr_gos_CODE] = GG.CODE,
	[gr_gos_name] = GG.name,
	date_begin = (SELECT min(date_begin) FROM staff WHERE link_up=sh.link),
	date_end = (SELECT max(date_end) FROM staff WHERE link_up=sh.link),
	[deleted] = case when isnull(@dDate, ui.workdate) between s.date_begin and s.date_end then 0 else 1 end,
	LINK_KBK 	= KBK.LINK,
	CODE_KBK	= KBK.CODE,
	NAME_KBK	= KBK.[NAME],
	--
	DEL_SUBDIV	= SD.deleted,
	date_begin_s = s.date_begin
FROM dbo.user_info ui
	INNER JOIN dbo.staff_head sh ON sh.dep_link = ui.dep_link or ui.code_task = 'KADRY'
	INNER JOIN dbo.staff s ON s.link_up=sh.link and
		s.date_begin=isnull((SELECT max(date_begin) FROM staff WHERE link_up=s.link_up and isnull(@dDate, ui.workdate)>=date_begin),
					(SELECT min(date_begin) FROM staff WHERE link_up=s.link_up and isnull(@dDate, ui.workdate)<=date_begin))
	INNER JOIN dbo.post_types pt ON s.gossl=pt.link
	LEFT JOIN (select LINK_UP, sum(SUMMA) as SUMMA from dbo.sa_dict_pays_staff(@dDATE,0) where Actual = 1 and isOklad = 1 GROUP BY LINK_UP) Oklad ON sh.link = Oklad.LINK_UP
	LEFT OUTER JOIN SUBDIVISION(@dDATE) SD ON SD.LINK = s.subdiv_link
	LEFT OUTER JOIN POST P ON P.LINK = s.post_link 
	LEFT OUTER JOIN KATEG K ON K.LINK = s.KAT_link
	LEFT OUTER JOIN KAT_GOS KG ON KG.LINK = S.kat_gos_link
	LEFT OUTER JOIN GR_GOS GG ON GG.LINK = S.gr_gos_link
	LEFT JOIN dbo.SAL_SFIN KBK on KBK.LINK = S.LINK_KBK

GO



if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DICTIONARY_STAFF]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[DICTIONARY_STAFF]
GO

CREATE VIEW DICTIONARY_STAFF
AS

SELECT *   
FROM dbo.DICTIONARY_STAFF_FN(default)

GO


IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'dbo.[SD_EMPL]') AND OBJECTPROPERTY(id, N'IsView') = 1)
DROP VIEW dbo.[SD_EMPL]

GO

CREATE VIEW [SD_EMPL]  AS 
SELECT * FROM dbo.SD_EMPL_FN( default, default)

GO


GRANT SELECT ON dbo.[SD_EMPL] TO PUBLIC

GO

